#pragma semicolon 1

#include <sourcemod>
#include <magic_crystals>

public Plugin:myinfo = 
{
	name	= "Magic Crystals Healing",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

new Handle:mch_hp;

public OnPluginStart()
{
	mch_hp = CreateConVar("mch_hp", "25", "Сколько HP добавляет кристалл", _, true, 1.0, true, 500.0);
	HookEvent("player_death", player_death);
}

public Action:Event_MagicCrystalsMustBeCreated()
{
	return Plugin_Stop;
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	if (GetRandomInt(1, 5) != 3)
		return;

	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	decl Float:origin[3];
	GetClientAbsOrigin(client, origin);
	CreateMagicCrystal(origin, Float:{0.0, -90.0, -90.0});
}

public Action:Event_MagicCrystalActivated(const Float:crystal_pos[3], client, team)
{
	new Handle:pack = CreateDataPack();
	CreateDataTimer(0.1, RemoveCrystal_Timer, pack);
	WritePackFloat(pack, crystal_pos[0]);
	WritePackFloat(pack, crystal_pos[1]);
	WritePackFloat(pack, crystal_pos[2]);

	new hp = GetConVarInt(mch_hp);
	SetEntProp(client, Prop_Send, "m_iHealth", GetEntProp(client, Prop_Send, "m_iHealth") + hp);
	PrintToChat(client, "\x04Кристалл пополнил ваши жизни на %d HP!", hp);

	return Plugin_Continue;
}

public Action:RemoveCrystal_Timer(Handle:timer, Handle:pack)
{
	ResetPack(pack);

	decl Float:origin[3];
	origin[0] = ReadPackFloat(pack);
	origin[1] = ReadPackFloat(pack);
	origin[2] = ReadPackFloat(pack);
	RemoveMagicCrystal(origin);

	return Plugin_Stop;
}